Program Servo;
Uses Crt;
const  BA = $3F8;     { COM 1 }
var Schleifenzeit : Real;
    ch : Char;

procedure Test;
var high, low: Byte;
    m : Word;
begin
   inline ($FA);          { CLI, Interrupt sperren }
   Port[$43] := $34;      { Timer 0, Mode 2 }
   Port[$40] := 0;        { Timer 0, low zurcksetzen }
   Port[$40] := 0;        { Timer 0, high zurcksetzen }
   For m:=1 to 1000 do;   { Zeitmeschleife }
   Port[$43] := $04;      { Timer 0, einfrieren }
   low := Port[$40];      { Timer 0 auslesen }
   high := Port[$40];
   inline ($FB);          { STI, Interrupt freigeben }
   Schleifenzeit := -(low + 256 * high) / 1000;
   writeln ('Zeit fr eine Schleife =   ',Schleifenzeit:5:3,' s');
   writeln;
 end;

procedure Impulsgenerator (Laenge: Integer);
var Anzeit,Auszeit,Anzahl, m: Word;
begin
   Anzeit := round (Laenge/Schleifenzeit);
   Auszeit := round (10000/Schleifenzeit);
   inline ($FA);                   { Interrupt aus }
   for Anzahl := 1 to 50 do begin
     Port[BA+4] := 1;              { DTR an }
     For M:=1 to Anzeit do;        { Impulszeit }
     Port [BA+4] := 0;             { DTR aus }
     For m:= 1 to Auszeit do;      { Pausenzeit }
   end;
   inline ($FB);
 end;

procedure Steuerung;
var n: integer;
begin
  for n:= 1 to 10 do Impulsgenerator (1000+n*100);
end;

begin
  Test;
  repeat
    Steuerung;
  until KeyPressed;
end.
